{{#*inline "scoreDetails"}}
    <div class="flexrow choice-part token-value" data-type="score">
        {{#if defense}}
            {{#if hide}}
                <span>?</span>
            {{else}}
                <span>{{score}}</span>
            {{/if}}
            <img src="systems/acariaempire/resources/interaction/tokens/defense_score.png">
        {{else}}
            <span>{{score}}</span>
            <img src="systems/acariaempire/resources/interaction/tokens/action_score.png">
        {{/if}}
    </div>
{{/inline}}
{{#*inline "tokenDetails"}}
    <div class="flexrow choice-part token-value" data-type="cardBalance">
        <span>{{tokens}}</span>
        <img src="systems/acariaempire/resources/interaction/tokens/card_balance_neutral.png">
    </div>
{{/inline}}

{{#*inline "lineDetails"}}

    {{#if line.tips}}
        <div class="choice-part tips">{{line.tips}}</div>
    {{/if}}

    {{#if line.score}}
        {{> scoreDetails score=line.score.value defense=defense hide=line.hideScore}}
    {{else}}
        <div class="flexrow choice-part token-value"> </div>
    {{/if}}

    {{#if line.tokens}}
        {{> tokenDetails tokens=line.tokens.value}}
    {{else}}
        <div class="flexrow choice-part token-value"> </div>
    {{/if}}
{{/inline}}

{{#*inline "sideScore"}}
<div class="flexrow configSummary token-part">
    <div class="flexrow token-value" title="{{score.label}}">
        <span>{{score.value}}</span>
        <img src={{score.icon}}>
    </div>

    {{#if tokens.list.length}}
        <div class="flexrow token-value" title="{{tokens.label}}">
            {{#each tokens.list as |icon|}}
                <img class="token-icon" src="{{icon}}" title="{{localize 'AESYSTEM.interaction.sheet.cardBalance.details'}}">
            {{/each}}
        </div>
    {{/if}}
</div>
{{/inline}}

{{#*inline "interactionHeaders"}}
<div class="flexrow headers">
    <div class="flexcol first-choice">
        <h2>{{mainActorData.impl.mainActor.name}}</h2>
        <h3>{{mainActorData.impl.methodName}}</h3>
    </div>
    <div class="flexcol second-choice">
        <h2>{{defenseData.impl.targetsTitle}}</h2>
        <h3>{{defenseData.impl.methodName}}</h3>
    </div>
</div>
{{/inline}}


{{#*inline "mainSidePanel"}}
<div class="flexcol side-panel first-choice {{#if state.actionPartDisplayed}}active{{/if}}">
    <img class="character-img" src="{{mainActorData.impl.img}}"/>

    <!-- Choose implem -->
    {{#each mainActorData.allChoices as |choice|}}
        <div class="roll-category {{choice.css}}" data-choice-type="parent" data-key="{{choice.key}}">{{choice.label}}
        </div>
        {{#each choice.subCategories as |subchoice|}}
            <div class="roll-category subcategory {{subchoice.css}}" data-choice-type="child" data-key="{{subchoice.key}}">{{subchoice.label}}</div>
        {{/each}}
    {{/each}}
</div>
{{/inline}}

{{#*inline "mainConfigPanel"}}
<div class="flexcol config-panel first-choice {{#if state.actionPartDisplayed}}active{{/if}}">

    <!-- Already in pool -->
    <div class="flexrow choice-line">
        <div class="choice-part">{{localize 'AESYSTEM.interaction.sheet.details.startedWith'}}</div>
        {{> lineDetails line=mainActorData.impl.startedWith }}
    </div>

    {{#each mainActorData.impl.simpleMessagesToDisplay as |line| }}
        <div class="flexrow choice-line">
            <div class="choice-part tips no-token">{{line}}</div>
        </div>
    {{/each}}

    <!-- Reminder -->
    {{#if mainActorData.impl.reminder.displayed }}
        <div class="flexrow choice-line reminder {{mainActorData.impl.reminder.css}}"
                data-ref="{{mainActorData.impl.reminder.ref}}">
            <div class="choice-part">{{mainActorData.impl.reminder.title}}</div>
            {{> lineDetails line=mainActorData.impl.reminder }}
        </div>
    {{/if}}

    <!-- Listboxes specific to current implem -->
    {{#each mainActorData.impl.listBoxes as |box|}}
        <div class="flexrow choice-line">
            <select class="choice-part option-select" data-selection="{{box.bind}}" {{#if ../state.selects.disabledOnActor}}disabled{{/if}} >
                {{#select box.choice}}
                    {{#each box.choices as |method|}}
                        <option value="{{method.key}}">{{method.label}}</option>
                    {{/each}}
                {{/select}}
            </select>
            {{> lineDetails line=box }}
        </div>
    {{/each}}

    <!-- Additional data : Designing spell. Done when circle has already been built -->
    {{#if calc.arcane.displayed}}
    <div class="flexcol arcane-result-section">

        <div class="subtitle">{{calc.arcane.title}}</div>
        <div class="flexrow carac-list">
            {{#each calc.arcane.caracs as |carac|}}
                <div class="flexrow spell-line carac-elem">
                    <span class="wa-link simple-data" data-shortcut="{{carac.shortcut}}"></span>
                    <span class="simple-data">Lvl {{carac.level}}</span>
                </div>
            {{/each}}

            {{#each calc.arcane.inputs as |input|}}
                <div class="flexcol spell-line multi-line" data-input="{{input.key}}">
                    <span class="simple-data">{{input.title}}</span>
                    {{#each input.availableChoices as |choice|}}
                        <span class="selection {{choice.css}} change-choice" data-key="{{choice.key}}">{{choice.name}}</span>
                    {{/each}}
                </div>
            {{/each}}
        </div>

    </div>
    {{/if}}

    <!-- Additional data : Designing miracle. Done when spirits has been already called -->
    {{#if calc.miracle.displayed}}
    <div class="flexcol miracle-section">

        <div class="subtitle">{{calc.miracle.title}}</div>
        <div class="flexrow card-list">
            {{#each calc.miracle.choices as |choice|}}
                <div class="flexrow card-choice" data-card="{{choice.id}}">
                    <div class="card-show">
                        <i class="far fa-question-circle"></i>
                    </div>
                    <div class="card-element{{choice.element.css}}">
                        <img class="card-icon" src="{{choice.element.icon}}">
                    </div>
                    <div class="card-effect{{choice.effect.css}}">
                        <img class="card-icon" src="{{choice.effect.icon}}">
                    </div>
                    <div class="card-bonus{{choice.bonus.css}}">
                        <img class="card-icon" src="{{choice.bonus.icon}}">
                    </div>
                </div>
            {{/each}}
        </div>
        <div class="flexrow">
            {{#each calc.miracle.inputs as |input|}}
                <div class="flexcol spell-line multi-line" data-input="{{input.key}}">
                    <span class="simple-data">{{input.title}}</span>
                    {{#each input.availableChoices as |choice|}}
                        <span class="selection {{choice.css}} change-choice" data-key="{{choice.key}}">{{choice.name}}</span>
                    {{/each}}
                </div>
            {{/each}}
        </div>
    </div>
    {{/if}}

    <div class="flexrow fill-space"></div>
    {{> sideScore score=calc.scores.actor tokens=calc.tokens.actor}}

</div>
{{/inline}}

{{#*inline "defenseConfigPanel"}}
<div class="flexcol config-panel second-choice {{#if state.defensePartDisplayed}}active{{/if}}">
    {{#each defenseData.impl.simpleMessagesToDisplay as |line| }}
        <div class="flexrow choice-line">
            <div class="choice-part tips no-token">{{line}}</div>
        </div>
    {{/each}}

    {{#each defenseData.impl.reminders as |line| }}
        <div class="flexrow choice-line reminder {{line.css}}"
                data-ref="{{line.ref}}">
            <div class="choice-part">{{line.title}}</div>
            {{> lineDetails line=line defense=1}}
        </div>
    {{/each}}

    {{#if calc.defenseModeDisplayed }}
        <div class="flexrow choice-line">
            <select class="choice-part option-select" data-selection="defenseOption" {{#if state.selects.disabledOnDefense}}disabled{{/if}} >
                {{#select defenseData.impl.defenseMode.key}}
                    {{#each defenseData.impl.availableDefenseOptions as |option|}}
                        <option value="{{option.key}}">{{option.label}}</option>
                    {{/each}}
                {{/select}}
            </select>
            {{> scoreDetails score=defenseData.impl.defenseMode.score defense=1}}
            {{> tokenDetails tokens=defenseData.impl.defenseMode.tokens}}
        </div>
    {{/if}}

    {{#each defenseData.impl.listBoxes as |box|}}
        <div class="flexrow choice-line">
            <select class="choice-part option-select" data-selection="{{box.bind}}" {{#if ../state.selects.disabledOnDefense}}disabled{{/if}} >
                {{#select box.choice}}
                    {{#each box.choices as |method|}}
                        <option value="{{method.key}}">{{method.label}}</option>
                    {{/each}}
                {{/select}}
            </select>
            {{> lineDetails line=box defense=1}}
        </div>
    {{/each}}

    <!-- Additional data : Building circle -->
    {{#if defenseData.impl.circleDisplayed }}
        <div class="flexrow">
            <div class="subtitle">{{defenseData.impl.circle.subtitle}}</div>
            <div class="flexrow circle-actions">
                {{#each defenseData.impl.circle.rightBtns as |btn|}}
                    <a class="circle-button" data-action="{{btn.action}}"><i class="{{btn.icon}}"></i></a>
                {{/each}}    
            </div>
        </div>
        {{#if defenseData.impl.circle.choosing}}
            <span class="subtitle-tips">{{localize 'AESYSTEM.interaction.sheet.circle.chooseCircle'}}</span>
            <div class="flexrow circle-choice">
                {{#each defenseData.impl.circleEffectList as |circle|}}
                    <div class="flexcol create-circle" data-effect="{{circle.effect}}" style="background-image: url({{circle.icon}});">
                        <div class="flexcol tooltip">{{circle.label}}</div>
                    </div>
                {{/each}}
            </div>
        {{else}}
            {{#if defenseData.impl.circle.gmAlter}}
                <span class="subtitle-tips">{{localize 'AESYSTEM.interaction.sheet.circle.caracAlteredByGM'}}</span>
            {{else}}
                <span class="subtitle-tips">{{localize 'AESYSTEM.interaction.sheet.circle.onClick'}}</span>
            {{/if}}
            <div class="flexrow circle-construction">
                {{#each defenseData.impl.circle.caracs as |carac|}}
                    <div class="flexcol circle-token circle-carac" data-carac="{{carac.name}}" >
                        <span class="token-bg carac-level" style="background-image: url({{carac.icon}});">{{carac.displayedLevel}}</span>
                        <span class="carac-name">{{carac.label}}</span>
                    </div>
                {{/each}}

                <!-- Last line -->
                {{#if defenseData.impl.circle.harmonization.choosePanel.displayed}}
                    <div class="flexcol harmonization-panel choosing" >
                        <div class="flexrow harmonization-icons">
                            {{#each defenseData.impl.circle.harmonization.choosePanel.availableElements as |element|}}
                                <img class="harmonization-element {{element.css}} select-harmonization" src="{{element.icon}}" data-element="{{element.key}}">
                            {{/each}}
                        </div>
                        <span class="carac-name">{{localize 'AESYSTEM.interaction.sheet.circle.selectHarmonization'}}</span>
                    </div>

                {{else}}
                    {{#if defenseData.impl.circle.fragility.displayed}}
                        <div class="flexcol circle-token circle-fragility" >
                            <span class="token-bg fragility-level" style="background-image: url({{defenseData.impl.circle.fragility.icon}});">{{defenseData.impl.circle.fragility.level}}</span>
                            <span class="carac-name">{{localize 'AESYSTEM.interaction.sheet.circle.fragility'}}</span>
                        </div>
                    {{/if}}
                    <div class="flexcol harmonization-panel current" >
                        <div class="flexrow harmonization-icons">
                            {{#each defenseData.impl.circle.harmonization.list as |element|}}
                                <img class="harmonization-element {{element.css}} change-harmonization" src="{{element.icon}}" data-element="{{element.oldValue}}">
                            {{/each}}
                        </div>
                        <span class="carac-name">{{localize 'AESYSTEM.interaction.sheet.circle.harmonizations'}}</span>
                    </div>
                {{/if}}
            </div>
        {{/if}}
    {{/if}}

    <!-- Additional data : Calling new spirits -->
    {{#if defenseData.impl.communionDisplayed }}
        <div class="subtitle">{{defenseData.impl.communion.subtitle}}</div>
        <div class="flexcol communion-part">

            <span class="subtitle-tips">{{localize 'AESYSTEM.interaction.sheet.communion.onClick'}}</span>
            <div class="flexrow spirit-tokens">
                <div class="flexcol spirit-token" >
                    <span class="token-bg clickable spirit-level {{defenseData.impl.communion.availableLevel.css}}" style="background-image: url({{defenseData.impl.communion.availableLevel.icon}});">{{defenseData.impl.communion.availableLevel.level}}</span>
                    <span class="token-name">{{defenseData.impl.communion.availableLevel.label}}</span>
                </div>

                <div class="flexcol spirit-token" >
                    <span class="token-bg clickable spirit-amount" style="background-image: url({{defenseData.impl.communion.callData.icon}});">{{defenseData.impl.communion.callData.quantity}}</span>
                    <span class="token-name">{{defenseData.impl.communion.callData.label}}</span>
                </div>

                {{#if defenseData.impl.communion.dissatisfaction.displayed }}
                    <div class="flexcol spirit-token" >
                        <span class="token-bg spirit-dissatisfaction" style="background-image: url({{defenseData.impl.communion.dissatisfaction.icon}});">{{defenseData.impl.communion.dissatisfaction.level}}</span>
                        <span class="token-name">{{defenseData.impl.communion.dissatisfaction.label}}</span>
                    </div>
                {{/if}}
            </div>
        </div>
    {{/if}}


    <!-- Additional data : Melody composition -->
    {{#if defenseData.impl.melodyDisplayed }}
        <div class="flexrow">
            <div class="subtitle">{{defenseData.impl.melody.title}}</div>
            <div class="flexrow melody-actions">
                {{#each defenseData.impl.melody.rightBtns as |btn|}}
                    <a class="melody-button" data-action="{{btn.action}}"><i class="{{btn.icon}}"></i></a>
                {{/each}}    
            </div>
        </div>

        {{#if defenseData.impl.melody.choosing}}
            <span class="subtitle-tips">{{localize 'AESYSTEM.interaction.sheet.melody.chooseMelody'}}</span>
            <div class="flexrow melody-choice">
                {{#each defenseData.impl.availableMelodyList as |melody|}}
                    <div class="flexcol create-melody" data-key="{{melody.key}}" style="background-image: url({{melody.icon}});">
                        <div class="tooltip">{{melody.label}}</div>
                    </div>
                {{/each}}
            </div>
        {{else}}
            {{#if defenseData.impl.melody.gmAlter}}
                <span class="subtitle-tips">{{localize 'AESYSTEM.interaction.sheet.melody.alteredByGM'}}</span>
            {{else}}
                <span class="subtitle-tips">{{localize 'AESYSTEM.interaction.sheet.melody.onClick'}}</span>
            {{/if}}
            <div class="flexrow melody-construction">
                <div class="flexcol melody-token melody-theme">
                    <span class="token-bg theme-level" style="background-image: url({{defenseData.impl.melody.icon}});">{{defenseData.impl.melody.displayedLevel}}</span>
                    <span class="token-name">{{defenseData.impl.melody.performance.melodyName}}</span>
                </div>
                {{#if defenseData.impl.melody.dissonanceDisplayed}}
                    <div class="flexcol melody-token" >
                        <span class="token-bg dissonance-level" style="background-image: url({{defenseData.impl.melody.dissonanceIcon}});">{{defenseData.impl.melody.dissonance}}</span>
                        <span class="token-name">{{localize 'AESYSTEM.interaction.sheet.melody.dissonance'}}</span>
                    </div>
                {{/if}}
            </div>
        {{/if}}
    {{/if}}

    <div class="flexrow fill-space"></div>
    {{> sideScore score=calc.scores.defense tokens=calc.tokens.defense }}
</div>
{{/inline}}

{{#*inline "defenseSidePanel"}}
<div class="flexcol side-panel second-choice {{#if state.defensePartDisplayed}}active{{/if}}">
    <img class="character-img" src="{{defenseData.impl.img}}"/>

    {{#each defenseData.allChoices as |choice|}}
        <div class="roll-category {{choice.css}}" data-key="{{choice.key}}">{{choice.label}}</div>
    {{/each}}
</div>
{{/inline}}

{{#*inline "middlePanel"}}
<div class="flexcol middle-panel">
    {{#if state.circleButton.displayed}}
        <div class="big-button circle-button"></div>
    {{/if}}
    {{#if state.melodyButton.displayed}}
        <div class="big-button melody-button"></div>
    {{/if}}
    {{#if state.spiritButton.displayed}}
        <div class="big-button spirit-button"></div>
    {{/if}}
    {{#if state.waitButton.displayed}}
        <div class="big-button wait-button"></div>
    {{/if}}
    {{#if state.answerButton.displayed}}
        <div class="big-button answer-button {{#if state.answerButton.active}}active{{/if}}"></div>
    {{/if}}
    {{#if state.versusButton.displayed}}
        <div class="big-button versus-button {{#if state.versusButton.active}}active{{/if}}"></div>
    {{/if}}
</div>
{{/inline}}

{{#*inline "rollPanel"}}
<div class="flexcol roll-panel {{#if state.riskPartDisplayed}}active{{/if}}">
    {{> sideScore score=calc.scores.all tokens=calc.tokens.all }}

    <!-- Action duration -->
    {{#if calc.timed.tracked}}
        {{> timeInput }}
    {{/if}}

    <!-- Risk -->
    {{> riskInput }}

    <!-- Roll buttons -->
    {{#if state.rollButton.displayed}}
    <div class="flexrow result-section">
        <div class="big-button roll-button {{#if state.rollButton.active}}active{{/if}}" data-type="roll"></div>
    </div>
    {{/if}}
</div>
{{/inline}}

{{#*inline "eventCardPanel"}}
<div class="flexcol bottom-side-panel card-choice {{calc.eventCard.cssState}}">
    {{#if calc.eventCard.chosen}}
        <p class="roll-title">{{calc.eventCard.rollBonus.name}}</p>
        <img class="roll-bonus" src="{{calc.eventCard.rollBonus.icon}}" >
        <p class="roll-tips">{{localize 'AESYSTEM.interaction.sheet.onroll.tips'}}</p>
    {{else}}{{#if calc.eventCard.available}}
        <p>{{localize 'AESYSTEM.interaction.sheet.onroll.available'}}</p>
    {{else}}    
        <p>{{localize 'AESYSTEM.interaction.sheet.onroll.none'}}</p>
    {{/if}}{{/if}}
</div>
{{/inline}}

{{#*inline "troublePanel"}}
<div class="flexcol bottom-side-panel trouble {{#if calc.trouble.active}}active{{/if}}">
    <p class="trouble-title">{{calc.trouble.label}}</p>
    {{#if calc.trouble.img.displayed}}
        <img class="trouble-img" src="{{calc.trouble.img.src}}" >
    {{/if}}
</div>
{{/inline}}

{{#*inline "timeInput"}}
<div class="flexcol last-inputs action-section">

    <div class="flexrow subtitle">{{calc.timed.label}}
        <i class="wa-tooltip far fa-question-circle" data-shortcut="interaction.system.resolve" data-child="section.time"></i>
    </div>

    <div class="flexrow">
        {{#each calc.timed.choices as |choice|}}
        <a class="change-action{{choice.active}}" title="{{choice.key}}" data-action="{{choice.key}}">
            <i class="{{choice.icon}}"></i>
        </a>
        {{/each}}
    </div>

</div>
{{/inline}}

{{#*inline "riskInput"}}
<div class="flexcol last-inputs risk-section">

    <div class="flexrow subtitle">{{calc.risk.label}}
            <i class="wa-tooltip far fa-question-circle" data-shortcut="interaction.system.resolve" data-child="section.risk"></i>
            <i class="show-stats far fa-chart-bar"></i>
    </div>
    <div class="flexrow">
        <div class="die-icon">
            <i class="fas fa-dice-d6"></i>
        </div>
        <div class="die-icon">
            <i class="fas fa-dice-d6"></i>
        </div>
        <div class="die-icon">
            <i class="fas fa-dice-d6"></i>
        </div>
        <a class="die-icon change-risk{{calc.risk.selection.risk1}}" title="Small risk" data-level="1">
            <i class="fas fa-dice-d6"></i>
        </a>
        <a class="die-icon change-risk{{calc.risk.selection.risk2}}" title="Medium risk" data-level="2">
            <i class="fas fa-dice-d6"></i>
        </a>
        <a class="die-icon change-risk{{calc.risk.selection.risk3}}" title="Large risk" data-level="3">
            <i class="fas fa-dice-d6"></i>
        </a>
        <a class="die-icon change-risk undo" title="No risk" data-level="0">
            <i class="fas fa-times"></i>
        </a>
    </div>

</div>
{{/inline}}

<div class="flexrow main-row">
    
    <!-- Side panel : Main actor image and roll category -->
    {{> mainSidePanel }}

    <div class="flexcol">

        {{> interactionHeaders }}

        <div class="flexrow">
            <!-- Config panel : Main actor choices -->
            {{> mainConfigPanel }}

            <!-- Middle panel : For buttons -->
            {{> middlePanel }}

            <!-- Config panel : For defense choices -->
            {{> defenseConfigPanel }}

        </div>
    </div>

    <!-- Side Panel : Defense image and defense category -->
    {{> defenseSidePanel }}
</div>

<!-- For choosing risk and roll dice -->
<div class="flexrow bottom-row {{#if state.rollButton.displayed}}margin-for-button{{/if}}">
    {{> eventCardPanel }}
    {{> rollPanel }}
    {{> troublePanel }}
</div>

